      SUBROUTINE AFG4D(A,M,N,NLEAD,RCOND,Z,IERR)
C***************************************************C
C  LU-PAOEHE METOOM AYCCA C BOPOM BEYEO  C
C  EMEHTA O CTOY  OEHKA CA OYCOBEH-   C
C  HOCT MATP A.                                 C
C***************************************************C
         INTEGER IERR,M,N,NLEAD
         DOUBLE PRECISION A,RCOND,Z
         DIMENSION A(M,1),NLEAD(1),Z(1)
         EXTERNAL UTAFSI
         INTEGER I,J,JJ,K,KB,KP1,L,LL,NM1
         DOUBLE PRECISION ANORM,EK,S,SM,T,WK,WKM,X,YNORM
       RCOND = 0.0D0
C
C  YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH
       X = 0.0D0
   10  CONTINUE
C
C  POBEPKA PABHOCT AAH APAMETPOB M  N
       IF (N .GE. 1 .AND. M .GE. 1) GO TO 20
          IERR = 65
          CALL UTAFSI(1HA,1HF,1HG,1H4,1HD,IERR)
          GO TO 760
   20  CONTINUE
       IERR = 0
C
C  BCEHE 1-HOPM MATP A
       ANORM = 0.D0
       K = MOD(N,6)
       KP1 = K + 1
       DO 70 J = 1, N
          T = 0.0D0
          IF (K .EQ. 0) GO TO 40
             DO 30 JJ = 1, K
                T = T + DABS(A(JJ,J))
   30        CONTINUE
             IF (N .LT. 6) GO TO 60
   40        CONTINUE
             DO 50 JJ = KP1, N, 6
                T = T + DABS(A(JJ,J)) + DABS(A(JJ+1,J)) + DABS(A(JJ+
     1              2,J)) + DABS(A(JJ+3,J)) + DABS(A(JJ+4,J)) +
     2              DABS(A(JJ+5,J))
   50        CONTINUE
   60     CONTINUE
          IF (T .GT. ANORM) ANORM = T
   70  CONTINUE
C
C  LU-PAOEHE MATP A
       NM1 = N - 1
       IF (NM1 .LT. 1) GO TO 240
          DO 230 K = 1, NM1
             KP1 = K + 1
C
C  HAXOEHE HEKCA BEYEO EMEHTA L
             L = K
             T = DABS(A(K,K))
             DO 90 J = KP1, N
                IF (DABS(A(J,K)) .LE. T) GO TO 80
                   L = J
                   T = DABS(A(J,K))
   80           CONTINUE
   90        CONTINUE
             NLEAD(K) = L
             IF (A(L,K) .EQ. 0.0D0) GO TO 210
C
C  EPECTAHOBKA,EC TPEYETC
                IF (L .EQ. K) GO TO 100
                   T = A(L,K)
                   A(L,K) = A(K,K)
                   A(K,K) = T
  100           CONTINUE
C
C  BCEHE MHOTEE
                T = -1.D0/A(K,K)
                J = N - K
                I = MOD(J,5) + K
                IF (I .EQ. K) GO TO 120
                   DO 110 J = KP1, I
                      A(J,K) = T*A(J,K)
  110              CONTINUE
  120           CONTINUE
                I = I + 1
                IF (I .GT. N) GO TO 140
                   DO 130 J = I, N, 5
                      A(J,K) = T*A(J,K)
                      A(J+1,K) = T*A(J+1,K)
                      A(J+2,K) = T*A(J+2,K)
                      A(J+3,K) = T*A(J+3,K)
                      A(J+4,K) = T*A(J+4,K)
  130              CONTINUE
  140           CONTINUE
C
C  AYCCOBO CKEHE
                DO 200 J = KP1, N
                   T = A(L,J)
                   IF (L .EQ. K) GO TO 150
                      A(L,J) = A(K,J)
                      A(K,J) = T
  150              CONTINUE
                   JJ = N - K
                   I = MOD(JJ,4) + K
                   IF (I .EQ. K) GO TO 170
                      DO 160 JJ = KP1, I
                         A(JJ,J) = A(JJ,J) + T*A(JJ,K)
  160                 CONTINUE
  170              CONTINUE
                   I = I + 1
                   IF (I .GT. N) GO TO 190
                      DO 180 JJ = I, N, 4
                         A(JJ,J) = A(JJ,J) + T*A(JJ,K)
                         A(JJ+1,J) = A(JJ+1,J) + T*A(JJ+1,K)
                         A(JJ+2,J) = A(JJ+2,J) + T*A(JJ+2,K)
                         A(JJ+3,J) = A(JJ+3,J) + T*A(JJ+3,K)
  180                 CONTINUE
  190              CONTINUE
  200           CONTINUE
                GO TO 220
  210     CONTINUE
          IERR = -K
  220     CONTINUE
  230  CONTINUE
  240  CONTINUE
       IF (A(N,N) .EQ. 0.0D0) IERR = -N
       NLEAD(N) = N
       IF (IERR .EQ. 0) GO TO 250
          CALL UTAFSI(1HA,1HF,1HG,1H4,1HD,IERR)
          GO TO 760
  250  CONTINUE
C
C  BCEHE RCOND-BEH,OPATHO CY OYCOBEHHOCT MATP A.
C   BCEH HOPM MATP INVERSE(A) PEAETC CCTEMA A*Z=Y,
C  E Y-PEEHE CCTEM TRANS(A)*Y=E;KOMOHEHT BEKTOPA E BPATC
C  TAKM OPAOM,TO MAKCMPOBAT HOPMY BEKTOPA W,E W-PEEHE
C  CCTEM TRANS(U)*W=E.
C
C  PEEHE CCTEM TRANS(U)*W=E OHOBPEMEHHO C BOPOM E
       EK = 1.D0
       IF (N .GE. 2) GO TO 260
          RCOND = 1.0D0
          GO TO 760
  260  CONTINUE
       DO 270 J = 1, N
          Z(J) = 0.0D0
  270  CONTINUE
       DO 410 K = 1, N
          IF (Z(K) .NE. 0.D0) EK = DSIGN(EK,-Z(K))
          IF (DABS(EK-Z(K)) .LE. DABS(A(K,K))) GO TO 340
             S = DABS(A(K,K))/DABS(EK-Z(K))
             ASSIGN 330 TO LL
  280     CONTINUE
          I = MOD(N,5)
          IF (I .EQ. 0) GO TO 300
             DO 290 JJ = 1, I
                Z(JJ) = S*Z(JJ)
  290        CONTINUE
             IF (N .LT. 5) GO TO 320
  300        CONTINUE
             I = I + 1
             DO 310 JJ = I, N, 5
                Z(JJ) = S*Z(JJ)
                Z(JJ+1) = S*Z(JJ+1)
                Z(JJ+2) = S*Z(JJ+2)
                Z(JJ+3) = S*Z(JJ+3)
                Z(JJ+4) = S*Z(JJ+4)
  310        CONTINUE
  320     CONTINUE
          GO TO LL,(330,480,530,570,620,660,670,750)
  330     CONTINUE
          EK = S*EK
  340     CONTINUE
          WK = EK - Z(K)
          WKM = -EK - Z(K)
          S = DABS(WK)
          SM = DABS(WKM)
          IF (A(K,K) .EQ. 0.0D0) GO TO 350
             WK = WK/A(K,K)
             WKM = WKM/A(K,K)
             GO TO 360
  350     CONTINUE
          WK = 1.D0
          WKM = 1.D0
  360     CONTINUE
          KP1 = K + 1
          IF (KP1 .GT. N) GO TO 400
             DO 370 J = KP1, N
                SM = SM + DABS(Z(J) + WKM*A(K,J))
                Z(J) = Z(J) + WK*A(K,J)
                S = S + DABS(Z(J))
  370        CONTINUE
             IF (S .GE. SM) GO TO 390
                T = WKM - WK
                WK = WKM
                DO 380 J = KP1, N
                   Z(J) = Z(J) + T*A(K,J)
  380           CONTINUE
  390        CONTINUE
  400     CONTINUE
          Z(K) = WK
  410  CONTINUE
       ASSIGN 470 TO LL
  420  CONTINUE
       S = 0.0D0
       I = MOD(N,6)
       IF (I .EQ. 0) GO TO 440
          DO 430 JJ = 1, I
             S = S + DABS(Z(JJ))
  430     CONTINUE
          IF (N .LT. 6) GO TO 460
  440     CONTINUE
          I = I + 1
          DO 450 JJ = I, N, 6
             S = S + DABS(Z(JJ)) + DABS(Z(JJ+1)) + DABS(Z(JJ+2)) +
     1           DABS(Z(JJ+3)) + DABS(Z(JJ+4)) + DABS(Z(JJ+5))
  450     CONTINUE
  460  CONTINUE
       S = 1.0D0/S
       GO TO LL,(470,560,650,740)
  470  CONTINUE
       ASSIGN 480 TO LL
       GO TO 280
  480  CONTINUE
C
C  PEEHE CCTEM TRANS(L)*Y=W
       DO 550 KB = 1, N
          K = N + 1 - KB
          IF (K .GE. N) GO TO 520
             KP1 = K + 1
             JJ = N - K
             I = MOD(JJ,5) + K
             IF (I .EQ. K) GO TO 500
                DO 490 JJ = KP1, I
                   Z(K) = Z(K) + A(JJ,K)*Z(JJ)
  490           CONTINUE
  500        CONTINUE
             I = I + 1
             IF (I .GT. N) GO TO 520
                DO 510 JJ = I, N, 5
                   Z(K) = Z(K) + A(JJ,K)*Z(JJ) + A(JJ+1,K)*Z(JJ+1)
     1                     + A(JJ+2,K)*Z(JJ+2) + A(JJ+3,K)*Z(JJ+3)
     2                     + A(JJ+4,K)*Z(JJ+4)
  510           CONTINUE
  520        CONTINUE
             IF (DABS(Z(K)) .LE. 1.0D0) GO TO 540
                S = 1.0D0/DABS(Z(K))
                ASSIGN 530 TO LL
                GO TO 280
  530     CONTINUE
  540     CONTINUE
          L = NLEAD(K)
          T = Z(L)
          Z(L) = Z(K)
          Z(K) = T
  550  CONTINUE
       ASSIGN 560 TO LL
       GO TO 420
  560  CONTINUE
       ASSIGN 570 TO LL
       GO TO 280
  570  CONTINUE
       YNORM = 1.D0
C
C  PEEHE CCTEM L*V=Y  BCEHE HOPM BEKTOPA Y
       DO 640 K = 1, N
          L = NLEAD(K)
          T = Z(L)
          Z(L) = Z(K)
          Z(K) = T
          IF (K .GE. N) GO TO 610
             KP1 = K + 1
             JJ = N - K
             I = MOD(JJ,4) + K
             IF (I .EQ. K) GO TO 590
                DO 580 JJ = KP1, I
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
  580           CONTINUE
  590        CONTINUE
             I = I + 1
             IF (I .GT. N) GO TO 610
                DO 600 JJ = I, N, 4
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
                   Z(JJ+1) = Z(JJ+1) + T*A(JJ+1,K)
                   Z(JJ+2) = Z(JJ+2) + T*A(JJ+2,K)
                   Z(JJ+3) = Z(JJ+3) + T*A(JJ+3,K)
  600           CONTINUE
  610        CONTINUE
             IF (DABS(Z(K)) .LE. 1.0D0) GO TO 630
                S = 1.0D0/DABS(Z(K))
                ASSIGN 620 TO LL
                GO TO 280
  620     CONTINUE
          YNORM = S*YNORM
  630     CONTINUE
  640  CONTINUE
       ASSIGN 650 TO LL
       GO TO 420
  650  CONTINUE
       ASSIGN 660 TO LL
       GO TO 280
  660  CONTINUE
       YNORM = S*YNORM
C
C  PEEHE CCTEM U*Z=V
       DO 730 KB = 1, N
          K = N + 1 - KB
          IF (DABS(Z(K)) .LE. DABS(A(K,K))) GO TO 680
             S = DABS(A(K,K))/DABS(Z(K))
             ASSIGN 670 TO LL
             GO TO 280
  670     CONTINUE
          YNORM = S*YNORM
  680     CONTINUE
          IF (A(K,K) .NE. 0.D0) Z(K) = Z(K)/A(K,K)
          IF (A(K,K) .EQ. 0.D0) Z(K) = 1.D0
          T = -Z(K)
          L = K - 1
          IF (L .LT. 1) GO TO 720
             I = MOD(L,4)
             IF (I .EQ. 0) GO TO 700
                DO 690 JJ = 1, I
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
  690           CONTINUE
  700        CONTINUE
             I = I + 1
             IF (I .GT. L) GO TO 720
                DO 710 JJ = I, L, 4
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
                   Z(JJ+1) = Z(JJ+1) + T*A(JJ+1,K)
                   Z(JJ+2) = Z(JJ+2) + T*A(JJ+2,K)
                   Z(JJ+3) = Z(JJ+3) + T*A(JJ+3,K)
  710           CONTINUE
  720        CONTINUE
  730     CONTINUE
          ASSIGN 740 TO LL
          GO TO 420
  740  CONTINUE
       ASSIGN 750 TO LL
       GO TO 280
  750  CONTINUE
       YNORM = S*YNORM
       IF (ANORM .NE. 0.D0) RCOND = YNORM/ANORM
  760  CONTINUE
       RETURN
      END
